/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using RestSharp;
using Xunit;

using spoonacular.Client;
using spoonacular.Api;
// uncomment below to import models
//using spoonacular.Model;

namespace spoonacular.Test.Api
{
    /// <summary>
    ///  Class for testing DefaultApi
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by OpenAPI Generator (https://openapi-generator.tech).
    /// Please update the test case below to test the API endpoint.
    /// </remarks>
    public class DefaultApiTests : IDisposable
    {
        private DefaultApi instance;

        public DefaultApiTests()
        {
            instance = new DefaultApi();
        }

        public void Dispose()
        {
            // Cleanup when everything is done.
        }

        /// <summary>
        /// Test an instance of DefaultApi
        /// </summary>
        [Fact]
        public void InstanceTest()
        {
            // TODO uncomment below to test 'IsType' DefaultApi
            //Assert.IsType<DefaultApi>(instance);
        }

        /// <summary>
        /// Test AnalyzeRecipe
        /// </summary>
        [Fact]
        public void AnalyzeRecipeTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //AnalyzeRecipeRequest analyzeRecipeRequest = null;
            //string? language = null;
            //bool? includeNutrition = null;
            //bool? includeTaste = null;
            //var response = instance.AnalyzeRecipe(analyzeRecipeRequest, language, includeNutrition, includeTaste);
            //Assert.IsType<Object>(response);
        }

        /// <summary>
        /// Test CreateRecipeCardGet
        /// </summary>
        [Fact]
        public void CreateRecipeCardGetTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //decimal id = null;
            //string? mask = null;
            //string? backgroundImage = null;
            //string? backgroundColor = null;
            //string? fontColor = null;
            //var response = instance.CreateRecipeCardGet(id, mask, backgroundImage, backgroundColor, fontColor);
            //Assert.IsType<Object>(response);
        }

        /// <summary>
        /// Test SearchRestaurants
        /// </summary>
        [Fact]
        public void SearchRestaurantsTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string? query = null;
            //decimal? lat = null;
            //decimal? lng = null;
            //decimal? distance = null;
            //decimal? budget = null;
            //string? cuisine = null;
            //decimal? minRating = null;
            //bool? isOpen = null;
            //string? sort = null;
            //decimal? page = null;
            //var response = instance.SearchRestaurants(query, lat, lng, distance, budget, cuisine, minRating, isOpen, sort, page);
            //Assert.IsType<SearchRestaurants200Response>(response);
        }
    }
}
