/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using RestSharp;
using Xunit;

using spoonacular.Client;
using spoonacular.Api;
// uncomment below to import models
//using spoonacular.Model;

namespace spoonacular.Test.Api
{
    /// <summary>
    ///  Class for testing MiscApi
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by OpenAPI Generator (https://openapi-generator.tech).
    /// Please update the test case below to test the API endpoint.
    /// </remarks>
    public class MiscApiTests : IDisposable
    {
        private MiscApi instance;

        public MiscApiTests()
        {
            instance = new MiscApi();
        }

        public void Dispose()
        {
            // Cleanup when everything is done.
        }

        /// <summary>
        /// Test an instance of MiscApi
        /// </summary>
        [Fact]
        public void InstanceTest()
        {
            // TODO uncomment below to test 'IsType' MiscApi
            //Assert.IsType<MiscApi>(instance);
        }

        /// <summary>
        /// Test DetectFoodInText
        /// </summary>
        [Fact]
        public void DetectFoodInTextTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string? contentType = null;
            //var response = instance.DetectFoodInText(contentType);
            //Assert.IsType<DetectFoodInText200Response>(response);
        }

        /// <summary>
        /// Test GetARandomFoodJoke
        /// </summary>
        [Fact]
        public void GetARandomFoodJokeTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //var response = instance.GetARandomFoodJoke();
            //Assert.IsType<GetARandomFoodJoke200Response>(response);
        }

        /// <summary>
        /// Test GetConversationSuggests
        /// </summary>
        [Fact]
        public void GetConversationSuggestsTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string query = null;
            //decimal? number = null;
            //var response = instance.GetConversationSuggests(query, number);
            //Assert.IsType<GetConversationSuggests200Response>(response);
        }

        /// <summary>
        /// Test GetRandomFoodTrivia
        /// </summary>
        [Fact]
        public void GetRandomFoodTriviaTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //var response = instance.GetRandomFoodTrivia();
            //Assert.IsType<GetRandomFoodTrivia200Response>(response);
        }

        /// <summary>
        /// Test ImageAnalysisByURL
        /// </summary>
        [Fact]
        public void ImageAnalysisByURLTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string imageUrl = null;
            //var response = instance.ImageAnalysisByURL(imageUrl);
            //Assert.IsType<ImageAnalysisByURL200Response>(response);
        }

        /// <summary>
        /// Test ImageClassificationByURL
        /// </summary>
        [Fact]
        public void ImageClassificationByURLTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string imageUrl = null;
            //var response = instance.ImageClassificationByURL(imageUrl);
            //Assert.IsType<ImageClassificationByURL200Response>(response);
        }

        /// <summary>
        /// Test SearchAllFood
        /// </summary>
        [Fact]
        public void SearchAllFoodTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string query = null;
            //int? offset = null;
            //int? number = null;
            //var response = instance.SearchAllFood(query, offset, number);
            //Assert.IsType<SearchAllFood200Response>(response);
        }

        /// <summary>
        /// Test SearchCustomFoods
        /// </summary>
        [Fact]
        public void SearchCustomFoodsTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string username = null;
            //string hash = null;
            //string? query = null;
            //int? offset = null;
            //int? number = null;
            //var response = instance.SearchCustomFoods(username, hash, query, offset, number);
            //Assert.IsType<SearchCustomFoods200Response>(response);
        }

        /// <summary>
        /// Test SearchFoodVideos
        /// </summary>
        [Fact]
        public void SearchFoodVideosTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string? query = null;
            //string? type = null;
            //string? cuisine = null;
            //string? diet = null;
            //string? includeIngredients = null;
            //string? excludeIngredients = null;
            //decimal? minLength = null;
            //decimal? maxLength = null;
            //int? offset = null;
            //int? number = null;
            //var response = instance.SearchFoodVideos(query, type, cuisine, diet, includeIngredients, excludeIngredients, minLength, maxLength, offset, number);
            //Assert.IsType<SearchFoodVideos200Response>(response);
        }

        /// <summary>
        /// Test SearchSiteContent
        /// </summary>
        [Fact]
        public void SearchSiteContentTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string query = null;
            //var response = instance.SearchSiteContent(query);
            //Assert.IsType<SearchSiteContent200Response>(response);
        }

        /// <summary>
        /// Test TalkToChatbot
        /// </summary>
        [Fact]
        public void TalkToChatbotTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string text = null;
            //string? contextId = null;
            //var response = instance.TalkToChatbot(text, contextId);
            //Assert.IsType<TalkToChatbot200Response>(response);
        }
    }
}
