/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using RestSharp;
using Xunit;

using spoonacular.Client;
using spoonacular.Api;
// uncomment below to import models
//using spoonacular.Model;

namespace spoonacular.Test.Api
{
    /// <summary>
    ///  Class for testing WineApi
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by OpenAPI Generator (https://openapi-generator.tech).
    /// Please update the test case below to test the API endpoint.
    /// </remarks>
    public class WineApiTests : IDisposable
    {
        private WineApi instance;

        public WineApiTests()
        {
            instance = new WineApi();
        }

        public void Dispose()
        {
            // Cleanup when everything is done.
        }

        /// <summary>
        /// Test an instance of WineApi
        /// </summary>
        [Fact]
        public void InstanceTest()
        {
            // TODO uncomment below to test 'IsType' WineApi
            //Assert.IsType<WineApi>(instance);
        }

        /// <summary>
        /// Test GetDishPairingForWine
        /// </summary>
        [Fact]
        public void GetDishPairingForWineTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string wine = null;
            //var response = instance.GetDishPairingForWine(wine);
            //Assert.IsType<GetDishPairingForWine200Response>(response);
        }

        /// <summary>
        /// Test GetWineDescription
        /// </summary>
        [Fact]
        public void GetWineDescriptionTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string wine = null;
            //var response = instance.GetWineDescription(wine);
            //Assert.IsType<GetWineDescription200Response>(response);
        }

        /// <summary>
        /// Test GetWinePairing
        /// </summary>
        [Fact]
        public void GetWinePairingTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string food = null;
            //decimal? maxPrice = null;
            //var response = instance.GetWinePairing(food, maxPrice);
            //Assert.IsType<GetWinePairing200Response>(response);
        }

        /// <summary>
        /// Test GetWineRecommendation
        /// </summary>
        [Fact]
        public void GetWineRecommendationTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string wine = null;
            //decimal? maxPrice = null;
            //decimal? minRating = null;
            //decimal? number = null;
            //var response = instance.GetWineRecommendation(wine, maxPrice, minRating, number);
            //Assert.IsType<GetWineRecommendation200Response>(response);
        }
    }
}
