/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using Xunit;

using System;
using System.Linq;
using System.IO;
using System.Collections.Generic;
using spoonacular.Model;
using spoonacular.Client;
using System.Reflection;
using Newtonsoft.Json;

namespace spoonacular.Test.Model
{
    /// <summary>
    ///  Class for testing GetIngredientInformation200Response
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by OpenAPI Generator (https://openapi-generator.tech).
    /// Please update the test case below to test the model.
    /// </remarks>
    public class GetIngredientInformation200ResponseTests : IDisposable
    {
        // TODO uncomment below to declare an instance variable for GetIngredientInformation200Response
        //private GetIngredientInformation200Response instance;

        public GetIngredientInformation200ResponseTests()
        {
            // TODO uncomment below to create an instance of GetIngredientInformation200Response
            //instance = new GetIngredientInformation200Response();
        }

        public void Dispose()
        {
            // Cleanup when everything is done.
        }

        /// <summary>
        /// Test an instance of GetIngredientInformation200Response
        /// </summary>
        [Fact]
        public void GetIngredientInformation200ResponseInstanceTest()
        {
            // TODO uncomment below to test "IsType" GetIngredientInformation200Response
            //Assert.IsType<GetIngredientInformation200Response>(instance);
        }

        /// <summary>
        /// Test the property 'Id'
        /// </summary>
        [Fact]
        public void IdTest()
        {
            // TODO unit test for the property 'Id'
        }

        /// <summary>
        /// Test the property 'Original'
        /// </summary>
        [Fact]
        public void OriginalTest()
        {
            // TODO unit test for the property 'Original'
        }

        /// <summary>
        /// Test the property 'OriginalName'
        /// </summary>
        [Fact]
        public void OriginalNameTest()
        {
            // TODO unit test for the property 'OriginalName'
        }

        /// <summary>
        /// Test the property 'Name'
        /// </summary>
        [Fact]
        public void NameTest()
        {
            // TODO unit test for the property 'Name'
        }

        /// <summary>
        /// Test the property 'NameClean'
        /// </summary>
        [Fact]
        public void NameCleanTest()
        {
            // TODO unit test for the property 'NameClean'
        }

        /// <summary>
        /// Test the property 'Amount'
        /// </summary>
        [Fact]
        public void AmountTest()
        {
            // TODO unit test for the property 'Amount'
        }

        /// <summary>
        /// Test the property 'Unit'
        /// </summary>
        [Fact]
        public void UnitTest()
        {
            // TODO unit test for the property 'Unit'
        }

        /// <summary>
        /// Test the property 'UnitShort'
        /// </summary>
        [Fact]
        public void UnitShortTest()
        {
            // TODO unit test for the property 'UnitShort'
        }

        /// <summary>
        /// Test the property 'UnitLong'
        /// </summary>
        [Fact]
        public void UnitLongTest()
        {
            // TODO unit test for the property 'UnitLong'
        }

        /// <summary>
        /// Test the property 'PossibleUnits'
        /// </summary>
        [Fact]
        public void PossibleUnitsTest()
        {
            // TODO unit test for the property 'PossibleUnits'
        }

        /// <summary>
        /// Test the property 'EstimatedCost'
        /// </summary>
        [Fact]
        public void EstimatedCostTest()
        {
            // TODO unit test for the property 'EstimatedCost'
        }

        /// <summary>
        /// Test the property 'Consistency'
        /// </summary>
        [Fact]
        public void ConsistencyTest()
        {
            // TODO unit test for the property 'Consistency'
        }

        /// <summary>
        /// Test the property 'ShoppingListUnits'
        /// </summary>
        [Fact]
        public void ShoppingListUnitsTest()
        {
            // TODO unit test for the property 'ShoppingListUnits'
        }

        /// <summary>
        /// Test the property 'Aisle'
        /// </summary>
        [Fact]
        public void AisleTest()
        {
            // TODO unit test for the property 'Aisle'
        }

        /// <summary>
        /// Test the property 'Image'
        /// </summary>
        [Fact]
        public void ImageTest()
        {
            // TODO unit test for the property 'Image'
        }

        /// <summary>
        /// Test the property 'Meta'
        /// </summary>
        [Fact]
        public void MetaTest()
        {
            // TODO unit test for the property 'Meta'
        }

        /// <summary>
        /// Test the property 'Nutrition'
        /// </summary>
        [Fact]
        public void NutritionTest()
        {
            // TODO unit test for the property 'Nutrition'
        }

        /// <summary>
        /// Test the property 'CategoryPath'
        /// </summary>
        [Fact]
        public void CategoryPathTest()
        {
            // TODO unit test for the property 'CategoryPath'
        }
    }
}
