/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using Xunit;

using System;
using System.Linq;
using System.IO;
using System.Collections.Generic;
using spoonacular.Model;
using spoonacular.Client;
using System.Reflection;
using Newtonsoft.Json;

namespace spoonacular.Test.Model
{
    /// <summary>
    ///  Class for testing SearchGroceryProductsByUPC200Response
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by OpenAPI Generator (https://openapi-generator.tech).
    /// Please update the test case below to test the model.
    /// </remarks>
    public class SearchGroceryProductsByUPC200ResponseTests : IDisposable
    {
        // TODO uncomment below to declare an instance variable for SearchGroceryProductsByUPC200Response
        //private SearchGroceryProductsByUPC200Response instance;

        public SearchGroceryProductsByUPC200ResponseTests()
        {
            // TODO uncomment below to create an instance of SearchGroceryProductsByUPC200Response
            //instance = new SearchGroceryProductsByUPC200Response();
        }

        public void Dispose()
        {
            // Cleanup when everything is done.
        }

        /// <summary>
        /// Test an instance of SearchGroceryProductsByUPC200Response
        /// </summary>
        [Fact]
        public void SearchGroceryProductsByUPC200ResponseInstanceTest()
        {
            // TODO uncomment below to test "IsType" SearchGroceryProductsByUPC200Response
            //Assert.IsType<SearchGroceryProductsByUPC200Response>(instance);
        }

        /// <summary>
        /// Test the property 'Id'
        /// </summary>
        [Fact]
        public void IdTest()
        {
            // TODO unit test for the property 'Id'
        }

        /// <summary>
        /// Test the property 'Title'
        /// </summary>
        [Fact]
        public void TitleTest()
        {
            // TODO unit test for the property 'Title'
        }

        /// <summary>
        /// Test the property 'Badges'
        /// </summary>
        [Fact]
        public void BadgesTest()
        {
            // TODO unit test for the property 'Badges'
        }

        /// <summary>
        /// Test the property 'ImportantBadges'
        /// </summary>
        [Fact]
        public void ImportantBadgesTest()
        {
            // TODO unit test for the property 'ImportantBadges'
        }

        /// <summary>
        /// Test the property 'Breadcrumbs'
        /// </summary>
        [Fact]
        public void BreadcrumbsTest()
        {
            // TODO unit test for the property 'Breadcrumbs'
        }

        /// <summary>
        /// Test the property 'GeneratedText'
        /// </summary>
        [Fact]
        public void GeneratedTextTest()
        {
            // TODO unit test for the property 'GeneratedText'
        }

        /// <summary>
        /// Test the property 'ImageType'
        /// </summary>
        [Fact]
        public void ImageTypeTest()
        {
            // TODO unit test for the property 'ImageType'
        }

        /// <summary>
        /// Test the property 'IngredientCount'
        /// </summary>
        [Fact]
        public void IngredientCountTest()
        {
            // TODO unit test for the property 'IngredientCount'
        }

        /// <summary>
        /// Test the property 'IngredientList'
        /// </summary>
        [Fact]
        public void IngredientListTest()
        {
            // TODO unit test for the property 'IngredientList'
        }

        /// <summary>
        /// Test the property 'Ingredients'
        /// </summary>
        [Fact]
        public void IngredientsTest()
        {
            // TODO unit test for the property 'Ingredients'
        }

        /// <summary>
        /// Test the property 'Likes'
        /// </summary>
        [Fact]
        public void LikesTest()
        {
            // TODO unit test for the property 'Likes'
        }

        /// <summary>
        /// Test the property 'Nutrition'
        /// </summary>
        [Fact]
        public void NutritionTest()
        {
            // TODO unit test for the property 'Nutrition'
        }

        /// <summary>
        /// Test the property 'Price'
        /// </summary>
        [Fact]
        public void PriceTest()
        {
            // TODO unit test for the property 'Price'
        }

        /// <summary>
        /// Test the property 'Servings'
        /// </summary>
        [Fact]
        public void ServingsTest()
        {
            // TODO unit test for the property 'Servings'
        }

        /// <summary>
        /// Test the property 'SpoonacularScore'
        /// </summary>
        [Fact]
        public void SpoonacularScoreTest()
        {
            // TODO unit test for the property 'SpoonacularScore'
        }
    }
}
