/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using Xunit;

using System;
using System.Linq;
using System.IO;
using System.Collections.Generic;
using spoonacular.Model;
using spoonacular.Client;
using System.Reflection;
using Newtonsoft.Json;

namespace spoonacular.Test.Model
{
    /// <summary>
    ///  Class for testing SearchRestaurants200ResponseRestaurantsInner
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by OpenAPI Generator (https://openapi-generator.tech).
    /// Please update the test case below to test the model.
    /// </remarks>
    public class SearchRestaurants200ResponseRestaurantsInnerTests : IDisposable
    {
        // TODO uncomment below to declare an instance variable for SearchRestaurants200ResponseRestaurantsInner
        //private SearchRestaurants200ResponseRestaurantsInner instance;

        public SearchRestaurants200ResponseRestaurantsInnerTests()
        {
            // TODO uncomment below to create an instance of SearchRestaurants200ResponseRestaurantsInner
            //instance = new SearchRestaurants200ResponseRestaurantsInner();
        }

        public void Dispose()
        {
            // Cleanup when everything is done.
        }

        /// <summary>
        /// Test an instance of SearchRestaurants200ResponseRestaurantsInner
        /// </summary>
        [Fact]
        public void SearchRestaurants200ResponseRestaurantsInnerInstanceTest()
        {
            // TODO uncomment below to test "IsType" SearchRestaurants200ResponseRestaurantsInner
            //Assert.IsType<SearchRestaurants200ResponseRestaurantsInner>(instance);
        }

        /// <summary>
        /// Test the property 'Id'
        /// </summary>
        [Fact]
        public void IdTest()
        {
            // TODO unit test for the property 'Id'
        }

        /// <summary>
        /// Test the property 'Name'
        /// </summary>
        [Fact]
        public void NameTest()
        {
            // TODO unit test for the property 'Name'
        }

        /// <summary>
        /// Test the property 'PhoneNumber'
        /// </summary>
        [Fact]
        public void PhoneNumberTest()
        {
            // TODO unit test for the property 'PhoneNumber'
        }

        /// <summary>
        /// Test the property 'Address'
        /// </summary>
        [Fact]
        public void AddressTest()
        {
            // TODO unit test for the property 'Address'
        }

        /// <summary>
        /// Test the property 'Type'
        /// </summary>
        [Fact]
        public void TypeTest()
        {
            // TODO unit test for the property 'Type'
        }

        /// <summary>
        /// Test the property 'Description'
        /// </summary>
        [Fact]
        public void DescriptionTest()
        {
            // TODO unit test for the property 'Description'
        }

        /// <summary>
        /// Test the property 'LocalHours'
        /// </summary>
        [Fact]
        public void LocalHoursTest()
        {
            // TODO unit test for the property 'LocalHours'
        }

        /// <summary>
        /// Test the property 'Cuisines'
        /// </summary>
        [Fact]
        public void CuisinesTest()
        {
            // TODO unit test for the property 'Cuisines'
        }

        /// <summary>
        /// Test the property 'FoodPhotos'
        /// </summary>
        [Fact]
        public void FoodPhotosTest()
        {
            // TODO unit test for the property 'FoodPhotos'
        }

        /// <summary>
        /// Test the property 'LogoPhotos'
        /// </summary>
        [Fact]
        public void LogoPhotosTest()
        {
            // TODO unit test for the property 'LogoPhotos'
        }

        /// <summary>
        /// Test the property 'StorePhotos'
        /// </summary>
        [Fact]
        public void StorePhotosTest()
        {
            // TODO unit test for the property 'StorePhotos'
        }

        /// <summary>
        /// Test the property 'DollarSigns'
        /// </summary>
        [Fact]
        public void DollarSignsTest()
        {
            // TODO unit test for the property 'DollarSigns'
        }

        /// <summary>
        /// Test the property 'PickupEnabled'
        /// </summary>
        [Fact]
        public void PickupEnabledTest()
        {
            // TODO unit test for the property 'PickupEnabled'
        }

        /// <summary>
        /// Test the property 'DeliveryEnabled'
        /// </summary>
        [Fact]
        public void DeliveryEnabledTest()
        {
            // TODO unit test for the property 'DeliveryEnabled'
        }

        /// <summary>
        /// Test the property 'IsOpen'
        /// </summary>
        [Fact]
        public void IsOpenTest()
        {
            // TODO unit test for the property 'IsOpen'
        }

        /// <summary>
        /// Test the property 'OffersFirstPartyDelivery'
        /// </summary>
        [Fact]
        public void OffersFirstPartyDeliveryTest()
        {
            // TODO unit test for the property 'OffersFirstPartyDelivery'
        }

        /// <summary>
        /// Test the property 'OffersThirdPartyDelivery'
        /// </summary>
        [Fact]
        public void OffersThirdPartyDeliveryTest()
        {
            // TODO unit test for the property 'OffersThirdPartyDelivery'
        }

        /// <summary>
        /// Test the property 'Miles'
        /// </summary>
        [Fact]
        public void MilesTest()
        {
            // TODO unit test for the property 'Miles'
        }

        /// <summary>
        /// Test the property 'WeightedRatingValue'
        /// </summary>
        [Fact]
        public void WeightedRatingValueTest()
        {
            // TODO unit test for the property 'WeightedRatingValue'
        }

        /// <summary>
        /// Test the property 'AggregatedRatingCount'
        /// </summary>
        [Fact]
        public void AggregatedRatingCountTest()
        {
            // TODO unit test for the property 'AggregatedRatingCount'
        }
    }
}
