/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = spoonacular.Client.OpenAPIDateConverter;

namespace spoonacular.Model
{
    /// <summary>
    /// ComputeGlycemicLoad200ResponseIngredientsInner
    /// </summary>
    [DataContract(Name = "computeGlycemicLoad_200_response_ingredients_inner")]
    public partial class ComputeGlycemicLoad200ResponseIngredientsInner : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ComputeGlycemicLoad200ResponseIngredientsInner" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ComputeGlycemicLoad200ResponseIngredientsInner() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ComputeGlycemicLoad200ResponseIngredientsInner" /> class.
        /// </summary>
        /// <param name="id">id (required).</param>
        /// <param name="original">original (required).</param>
        /// <param name="glycemicIndex">glycemicIndex (required).</param>
        /// <param name="glycemicLoad">glycemicLoad (required).</param>
        public ComputeGlycemicLoad200ResponseIngredientsInner(int id = default(int), string original = default(string), decimal glycemicIndex = default(decimal), decimal glycemicLoad = default(decimal))
        {
            this.Id = id;
            // to ensure "original" is required (not null)
            if (original == null)
            {
                throw new ArgumentNullException("original is a required property for ComputeGlycemicLoad200ResponseIngredientsInner and cannot be null");
            }
            this.Original = original;
            this.GlycemicIndex = glycemicIndex;
            this.GlycemicLoad = glycemicLoad;
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", IsRequired = true, EmitDefaultValue = true)]
        public int Id { get; set; }

        /// <summary>
        /// Gets or Sets Original
        /// </summary>
        [DataMember(Name = "original", IsRequired = true, EmitDefaultValue = true)]
        public string Original { get; set; }

        /// <summary>
        /// Gets or Sets GlycemicIndex
        /// </summary>
        [DataMember(Name = "glycemicIndex", IsRequired = true, EmitDefaultValue = true)]
        public decimal GlycemicIndex { get; set; }

        /// <summary>
        /// Gets or Sets GlycemicLoad
        /// </summary>
        [DataMember(Name = "glycemicLoad", IsRequired = true, EmitDefaultValue = true)]
        public decimal GlycemicLoad { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ComputeGlycemicLoad200ResponseIngredientsInner {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Original: ").Append(Original).Append("\n");
            sb.Append("  GlycemicIndex: ").Append(GlycemicIndex).Append("\n");
            sb.Append("  GlycemicLoad: ").Append(GlycemicLoad).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Original (string) minLength
            if (this.Original != null && this.Original.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Original, length must be greater than 1.", new [] { "Original" });
            }

            yield break;
        }
    }

}
