/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = spoonacular.Client.OpenAPIDateConverter;

namespace spoonacular.Model
{
    /// <summary>
    /// GetComparableProducts200ResponseComparableProducts
    /// </summary>
    [DataContract(Name = "getComparableProducts_200_response_comparableProducts")]
    public partial class GetComparableProducts200ResponseComparableProducts : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="GetComparableProducts200ResponseComparableProducts" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected GetComparableProducts200ResponseComparableProducts() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="GetComparableProducts200ResponseComparableProducts" /> class.
        /// </summary>
        /// <param name="calories">calories (required).</param>
        /// <param name="likes">likes (required).</param>
        /// <param name="price">price (required).</param>
        /// <param name="protein">protein (required).</param>
        /// <param name="spoonacularScore">spoonacularScore (required).</param>
        /// <param name="sugar">sugar (required).</param>
        public GetComparableProducts200ResponseComparableProducts(List<Object> calories = default(List<Object>), List<Object> likes = default(List<Object>), List<Object> price = default(List<Object>), List<GetComparableProducts200ResponseComparableProductsProteinInner> protein = default(List<GetComparableProducts200ResponseComparableProductsProteinInner>), List<GetComparableProducts200ResponseComparableProductsProteinInner> spoonacularScore = default(List<GetComparableProducts200ResponseComparableProductsProteinInner>), List<Object> sugar = default(List<Object>))
        {
            // to ensure "calories" is required (not null)
            if (calories == null)
            {
                throw new ArgumentNullException("calories is a required property for GetComparableProducts200ResponseComparableProducts and cannot be null");
            }
            this.Calories = calories;
            // to ensure "likes" is required (not null)
            if (likes == null)
            {
                throw new ArgumentNullException("likes is a required property for GetComparableProducts200ResponseComparableProducts and cannot be null");
            }
            this.Likes = likes;
            // to ensure "price" is required (not null)
            if (price == null)
            {
                throw new ArgumentNullException("price is a required property for GetComparableProducts200ResponseComparableProducts and cannot be null");
            }
            this.Price = price;
            // to ensure "protein" is required (not null)
            if (protein == null)
            {
                throw new ArgumentNullException("protein is a required property for GetComparableProducts200ResponseComparableProducts and cannot be null");
            }
            this.Protein = protein;
            // to ensure "spoonacularScore" is required (not null)
            if (spoonacularScore == null)
            {
                throw new ArgumentNullException("spoonacularScore is a required property for GetComparableProducts200ResponseComparableProducts and cannot be null");
            }
            this.SpoonacularScore = spoonacularScore;
            // to ensure "sugar" is required (not null)
            if (sugar == null)
            {
                throw new ArgumentNullException("sugar is a required property for GetComparableProducts200ResponseComparableProducts and cannot be null");
            }
            this.Sugar = sugar;
        }

        /// <summary>
        /// Gets or Sets Calories
        /// </summary>
        [DataMember(Name = "calories", IsRequired = true, EmitDefaultValue = true)]
        public List<Object> Calories { get; set; }

        /// <summary>
        /// Gets or Sets Likes
        /// </summary>
        [DataMember(Name = "likes", IsRequired = true, EmitDefaultValue = true)]
        public List<Object> Likes { get; set; }

        /// <summary>
        /// Gets or Sets Price
        /// </summary>
        [DataMember(Name = "price", IsRequired = true, EmitDefaultValue = true)]
        public List<Object> Price { get; set; }

        /// <summary>
        /// Gets or Sets Protein
        /// </summary>
        [DataMember(Name = "protein", IsRequired = true, EmitDefaultValue = true)]
        public List<GetComparableProducts200ResponseComparableProductsProteinInner> Protein { get; set; }

        /// <summary>
        /// Gets or Sets SpoonacularScore
        /// </summary>
        [DataMember(Name = "spoonacularScore", IsRequired = true, EmitDefaultValue = true)]
        public List<GetComparableProducts200ResponseComparableProductsProteinInner> SpoonacularScore { get; set; }

        /// <summary>
        /// Gets or Sets Sugar
        /// </summary>
        [DataMember(Name = "sugar", IsRequired = true, EmitDefaultValue = true)]
        public List<Object> Sugar { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class GetComparableProducts200ResponseComparableProducts {\n");
            sb.Append("  Calories: ").Append(Calories).Append("\n");
            sb.Append("  Likes: ").Append(Likes).Append("\n");
            sb.Append("  Price: ").Append(Price).Append("\n");
            sb.Append("  Protein: ").Append(Protein).Append("\n");
            sb.Append("  SpoonacularScore: ").Append(SpoonacularScore).Append("\n");
            sb.Append("  Sugar: ").Append(Sugar).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
