/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = spoonacular.Client.OpenAPIDateConverter;

namespace spoonacular.Model
{
    /// <summary>
    /// GetIngredientInformation200Response
    /// </summary>
    [DataContract(Name = "getIngredientInformation_200_response")]
    public partial class GetIngredientInformation200Response : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="GetIngredientInformation200Response" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected GetIngredientInformation200Response() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="GetIngredientInformation200Response" /> class.
        /// </summary>
        /// <param name="id">id (required).</param>
        /// <param name="original">original (required).</param>
        /// <param name="originalName">originalName (required).</param>
        /// <param name="name">name (required).</param>
        /// <param name="nameClean">nameClean (required).</param>
        /// <param name="amount">amount (required).</param>
        /// <param name="unit">unit (required).</param>
        /// <param name="unitShort">unitShort (required).</param>
        /// <param name="unitLong">unitLong (required).</param>
        /// <param name="possibleUnits">possibleUnits (required).</param>
        /// <param name="estimatedCost">estimatedCost (required).</param>
        /// <param name="consistency">consistency (required).</param>
        /// <param name="shoppingListUnits">shoppingListUnits (required).</param>
        /// <param name="aisle">aisle (required).</param>
        /// <param name="image">image (required).</param>
        /// <param name="meta">meta (required).</param>
        /// <param name="nutrition">nutrition (required).</param>
        /// <param name="categoryPath">categoryPath (required).</param>
        public GetIngredientInformation200Response(int id = default(int), string original = default(string), string originalName = default(string), string name = default(string), string nameClean = default(string), decimal amount = default(decimal), string unit = default(string), string unitShort = default(string), string unitLong = default(string), List<string> possibleUnits = default(List<string>), ParseIngredients200ResponseInnerEstimatedCost estimatedCost = default(ParseIngredients200ResponseInnerEstimatedCost), string consistency = default(string), List<string> shoppingListUnits = default(List<string>), string aisle = default(string), string image = default(string), List<Object> meta = default(List<Object>), GetIngredientInformation200ResponseNutrition nutrition = default(GetIngredientInformation200ResponseNutrition), List<string> categoryPath = default(List<string>))
        {
            this.Id = id;
            // to ensure "original" is required (not null)
            if (original == null)
            {
                throw new ArgumentNullException("original is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.Original = original;
            // to ensure "originalName" is required (not null)
            if (originalName == null)
            {
                throw new ArgumentNullException("originalName is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.OriginalName = originalName;
            // to ensure "name" is required (not null)
            if (name == null)
            {
                throw new ArgumentNullException("name is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.Name = name;
            // to ensure "nameClean" is required (not null)
            if (nameClean == null)
            {
                throw new ArgumentNullException("nameClean is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.NameClean = nameClean;
            this.Amount = amount;
            // to ensure "unit" is required (not null)
            if (unit == null)
            {
                throw new ArgumentNullException("unit is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.Unit = unit;
            // to ensure "unitShort" is required (not null)
            if (unitShort == null)
            {
                throw new ArgumentNullException("unitShort is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.UnitShort = unitShort;
            // to ensure "unitLong" is required (not null)
            if (unitLong == null)
            {
                throw new ArgumentNullException("unitLong is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.UnitLong = unitLong;
            // to ensure "possibleUnits" is required (not null)
            if (possibleUnits == null)
            {
                throw new ArgumentNullException("possibleUnits is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.PossibleUnits = possibleUnits;
            // to ensure "estimatedCost" is required (not null)
            if (estimatedCost == null)
            {
                throw new ArgumentNullException("estimatedCost is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.EstimatedCost = estimatedCost;
            // to ensure "consistency" is required (not null)
            if (consistency == null)
            {
                throw new ArgumentNullException("consistency is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.Consistency = consistency;
            // to ensure "shoppingListUnits" is required (not null)
            if (shoppingListUnits == null)
            {
                throw new ArgumentNullException("shoppingListUnits is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.ShoppingListUnits = shoppingListUnits;
            // to ensure "aisle" is required (not null)
            if (aisle == null)
            {
                throw new ArgumentNullException("aisle is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.Aisle = aisle;
            // to ensure "image" is required (not null)
            if (image == null)
            {
                throw new ArgumentNullException("image is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.Image = image;
            // to ensure "meta" is required (not null)
            if (meta == null)
            {
                throw new ArgumentNullException("meta is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.Meta = meta;
            // to ensure "nutrition" is required (not null)
            if (nutrition == null)
            {
                throw new ArgumentNullException("nutrition is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.Nutrition = nutrition;
            // to ensure "categoryPath" is required (not null)
            if (categoryPath == null)
            {
                throw new ArgumentNullException("categoryPath is a required property for GetIngredientInformation200Response and cannot be null");
            }
            this.CategoryPath = categoryPath;
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", IsRequired = true, EmitDefaultValue = true)]
        public int Id { get; set; }

        /// <summary>
        /// Gets or Sets Original
        /// </summary>
        [DataMember(Name = "original", IsRequired = true, EmitDefaultValue = true)]
        public string Original { get; set; }

        /// <summary>
        /// Gets or Sets OriginalName
        /// </summary>
        [DataMember(Name = "originalName", IsRequired = true, EmitDefaultValue = true)]
        public string OriginalName { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name = "name", IsRequired = true, EmitDefaultValue = true)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets NameClean
        /// </summary>
        [DataMember(Name = "nameClean", IsRequired = true, EmitDefaultValue = true)]
        public string NameClean { get; set; }

        /// <summary>
        /// Gets or Sets Amount
        /// </summary>
        [DataMember(Name = "amount", IsRequired = true, EmitDefaultValue = true)]
        public decimal Amount { get; set; }

        /// <summary>
        /// Gets or Sets Unit
        /// </summary>
        [DataMember(Name = "unit", IsRequired = true, EmitDefaultValue = true)]
        public string Unit { get; set; }

        /// <summary>
        /// Gets or Sets UnitShort
        /// </summary>
        [DataMember(Name = "unitShort", IsRequired = true, EmitDefaultValue = true)]
        public string UnitShort { get; set; }

        /// <summary>
        /// Gets or Sets UnitLong
        /// </summary>
        [DataMember(Name = "unitLong", IsRequired = true, EmitDefaultValue = true)]
        public string UnitLong { get; set; }

        /// <summary>
        /// Gets or Sets PossibleUnits
        /// </summary>
        [DataMember(Name = "possibleUnits", IsRequired = true, EmitDefaultValue = true)]
        public List<string> PossibleUnits { get; set; }

        /// <summary>
        /// Gets or Sets EstimatedCost
        /// </summary>
        [DataMember(Name = "estimatedCost", IsRequired = true, EmitDefaultValue = true)]
        public ParseIngredients200ResponseInnerEstimatedCost EstimatedCost { get; set; }

        /// <summary>
        /// Gets or Sets Consistency
        /// </summary>
        [DataMember(Name = "consistency", IsRequired = true, EmitDefaultValue = true)]
        public string Consistency { get; set; }

        /// <summary>
        /// Gets or Sets ShoppingListUnits
        /// </summary>
        [DataMember(Name = "shoppingListUnits", IsRequired = true, EmitDefaultValue = true)]
        public List<string> ShoppingListUnits { get; set; }

        /// <summary>
        /// Gets or Sets Aisle
        /// </summary>
        [DataMember(Name = "aisle", IsRequired = true, EmitDefaultValue = true)]
        public string Aisle { get; set; }

        /// <summary>
        /// Gets or Sets Image
        /// </summary>
        [DataMember(Name = "image", IsRequired = true, EmitDefaultValue = true)]
        public string Image { get; set; }

        /// <summary>
        /// Gets or Sets Meta
        /// </summary>
        [DataMember(Name = "meta", IsRequired = true, EmitDefaultValue = true)]
        public List<Object> Meta { get; set; }

        /// <summary>
        /// Gets or Sets Nutrition
        /// </summary>
        [DataMember(Name = "nutrition", IsRequired = true, EmitDefaultValue = true)]
        public GetIngredientInformation200ResponseNutrition Nutrition { get; set; }

        /// <summary>
        /// Gets or Sets CategoryPath
        /// </summary>
        [DataMember(Name = "categoryPath", IsRequired = true, EmitDefaultValue = true)]
        public List<string> CategoryPath { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class GetIngredientInformation200Response {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Original: ").Append(Original).Append("\n");
            sb.Append("  OriginalName: ").Append(OriginalName).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  NameClean: ").Append(NameClean).Append("\n");
            sb.Append("  Amount: ").Append(Amount).Append("\n");
            sb.Append("  Unit: ").Append(Unit).Append("\n");
            sb.Append("  UnitShort: ").Append(UnitShort).Append("\n");
            sb.Append("  UnitLong: ").Append(UnitLong).Append("\n");
            sb.Append("  PossibleUnits: ").Append(PossibleUnits).Append("\n");
            sb.Append("  EstimatedCost: ").Append(EstimatedCost).Append("\n");
            sb.Append("  Consistency: ").Append(Consistency).Append("\n");
            sb.Append("  ShoppingListUnits: ").Append(ShoppingListUnits).Append("\n");
            sb.Append("  Aisle: ").Append(Aisle).Append("\n");
            sb.Append("  Image: ").Append(Image).Append("\n");
            sb.Append("  Meta: ").Append(Meta).Append("\n");
            sb.Append("  Nutrition: ").Append(Nutrition).Append("\n");
            sb.Append("  CategoryPath: ").Append(CategoryPath).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Original (string) minLength
            if (this.Original != null && this.Original.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Original, length must be greater than 1.", new [] { "Original" });
            }

            // OriginalName (string) minLength
            if (this.OriginalName != null && this.OriginalName.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for OriginalName, length must be greater than 1.", new [] { "OriginalName" });
            }

            // Name (string) minLength
            if (this.Name != null && this.Name.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Name, length must be greater than 1.", new [] { "Name" });
            }

            // NameClean (string) minLength
            if (this.NameClean != null && this.NameClean.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for NameClean, length must be greater than 1.", new [] { "NameClean" });
            }

            // Consistency (string) minLength
            if (this.Consistency != null && this.Consistency.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Consistency, length must be greater than 1.", new [] { "Consistency" });
            }

            // Aisle (string) minLength
            if (this.Aisle != null && this.Aisle.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Aisle, length must be greater than 1.", new [] { "Aisle" });
            }

            // Image (string) minLength
            if (this.Image != null && this.Image.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Image, length must be greater than 1.", new [] { "Image" });
            }

            yield break;
        }
    }

}
