/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = spoonacular.Client.OpenAPIDateConverter;

namespace spoonacular.Model
{
    /// <summary>
    /// GetProductInformation200Response
    /// </summary>
    [DataContract(Name = "getProductInformation_200_response")]
    public partial class GetProductInformation200Response : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="GetProductInformation200Response" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected GetProductInformation200Response() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="GetProductInformation200Response" /> class.
        /// </summary>
        /// <param name="id">id (required).</param>
        /// <param name="title">title (required).</param>
        /// <param name="breadcrumbs">breadcrumbs (required).</param>
        /// <param name="imageType">imageType (required).</param>
        /// <param name="badges">badges (required).</param>
        /// <param name="importantBadges">importantBadges (required).</param>
        /// <param name="ingredientCount">ingredientCount (required).</param>
        /// <param name="generatedText">generatedText.</param>
        /// <param name="ingredientList">ingredientList (required).</param>
        /// <param name="ingredients">ingredients (required).</param>
        /// <param name="likes">likes (required).</param>
        /// <param name="aisle">aisle (required).</param>
        /// <param name="nutrition">nutrition (required).</param>
        /// <param name="price">price (required).</param>
        /// <param name="servings">servings (required).</param>
        /// <param name="spoonacularScore">spoonacularScore (required).</param>
        public GetProductInformation200Response(int id = default(int), string title = default(string), List<string> breadcrumbs = default(List<string>), string imageType = default(string), List<string> badges = default(List<string>), List<string> importantBadges = default(List<string>), int ingredientCount = default(int), Object generatedText = default(Object), string ingredientList = default(string), List<GetProductInformation200ResponseIngredientsInner> ingredients = default(List<GetProductInformation200ResponseIngredientsInner>), decimal likes = default(decimal), string aisle = default(string), SearchGroceryProductsByUPC200ResponseNutrition nutrition = default(SearchGroceryProductsByUPC200ResponseNutrition), decimal price = default(decimal), SearchGroceryProductsByUPC200ResponseServings servings = default(SearchGroceryProductsByUPC200ResponseServings), decimal spoonacularScore = default(decimal))
        {
            this.Id = id;
            // to ensure "title" is required (not null)
            if (title == null)
            {
                throw new ArgumentNullException("title is a required property for GetProductInformation200Response and cannot be null");
            }
            this.Title = title;
            // to ensure "breadcrumbs" is required (not null)
            if (breadcrumbs == null)
            {
                throw new ArgumentNullException("breadcrumbs is a required property for GetProductInformation200Response and cannot be null");
            }
            this.Breadcrumbs = breadcrumbs;
            // to ensure "imageType" is required (not null)
            if (imageType == null)
            {
                throw new ArgumentNullException("imageType is a required property for GetProductInformation200Response and cannot be null");
            }
            this.ImageType = imageType;
            // to ensure "badges" is required (not null)
            if (badges == null)
            {
                throw new ArgumentNullException("badges is a required property for GetProductInformation200Response and cannot be null");
            }
            this.Badges = badges;
            // to ensure "importantBadges" is required (not null)
            if (importantBadges == null)
            {
                throw new ArgumentNullException("importantBadges is a required property for GetProductInformation200Response and cannot be null");
            }
            this.ImportantBadges = importantBadges;
            this.IngredientCount = ingredientCount;
            // to ensure "ingredientList" is required (not null)
            if (ingredientList == null)
            {
                throw new ArgumentNullException("ingredientList is a required property for GetProductInformation200Response and cannot be null");
            }
            this.IngredientList = ingredientList;
            // to ensure "ingredients" is required (not null)
            if (ingredients == null)
            {
                throw new ArgumentNullException("ingredients is a required property for GetProductInformation200Response and cannot be null");
            }
            this.Ingredients = ingredients;
            this.Likes = likes;
            // to ensure "aisle" is required (not null)
            if (aisle == null)
            {
                throw new ArgumentNullException("aisle is a required property for GetProductInformation200Response and cannot be null");
            }
            this.Aisle = aisle;
            // to ensure "nutrition" is required (not null)
            if (nutrition == null)
            {
                throw new ArgumentNullException("nutrition is a required property for GetProductInformation200Response and cannot be null");
            }
            this.Nutrition = nutrition;
            this.Price = price;
            // to ensure "servings" is required (not null)
            if (servings == null)
            {
                throw new ArgumentNullException("servings is a required property for GetProductInformation200Response and cannot be null");
            }
            this.Servings = servings;
            this.SpoonacularScore = spoonacularScore;
            this.GeneratedText = generatedText;
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", IsRequired = true, EmitDefaultValue = true)]
        public int Id { get; set; }

        /// <summary>
        /// Gets or Sets Title
        /// </summary>
        [DataMember(Name = "title", IsRequired = true, EmitDefaultValue = true)]
        public string Title { get; set; }

        /// <summary>
        /// Gets or Sets Breadcrumbs
        /// </summary>
        [DataMember(Name = "breadcrumbs", IsRequired = true, EmitDefaultValue = true)]
        public List<string> Breadcrumbs { get; set; }

        /// <summary>
        /// Gets or Sets ImageType
        /// </summary>
        [DataMember(Name = "imageType", IsRequired = true, EmitDefaultValue = true)]
        public string ImageType { get; set; }

        /// <summary>
        /// Gets or Sets Badges
        /// </summary>
        [DataMember(Name = "badges", IsRequired = true, EmitDefaultValue = true)]
        public List<string> Badges { get; set; }

        /// <summary>
        /// Gets or Sets ImportantBadges
        /// </summary>
        [DataMember(Name = "importantBadges", IsRequired = true, EmitDefaultValue = true)]
        public List<string> ImportantBadges { get; set; }

        /// <summary>
        /// Gets or Sets IngredientCount
        /// </summary>
        [DataMember(Name = "ingredientCount", IsRequired = true, EmitDefaultValue = true)]
        public int IngredientCount { get; set; }

        /// <summary>
        /// Gets or Sets GeneratedText
        /// </summary>
        [DataMember(Name = "generatedText", EmitDefaultValue = true)]
        public Object GeneratedText { get; set; }

        /// <summary>
        /// Gets or Sets IngredientList
        /// </summary>
        [DataMember(Name = "ingredientList", IsRequired = true, EmitDefaultValue = true)]
        public string IngredientList { get; set; }

        /// <summary>
        /// Gets or Sets Ingredients
        /// </summary>
        [DataMember(Name = "ingredients", IsRequired = true, EmitDefaultValue = true)]
        public List<GetProductInformation200ResponseIngredientsInner> Ingredients { get; set; }

        /// <summary>
        /// Gets or Sets Likes
        /// </summary>
        [DataMember(Name = "likes", IsRequired = true, EmitDefaultValue = true)]
        public decimal Likes { get; set; }

        /// <summary>
        /// Gets or Sets Aisle
        /// </summary>
        [DataMember(Name = "aisle", IsRequired = true, EmitDefaultValue = true)]
        public string Aisle { get; set; }

        /// <summary>
        /// Gets or Sets Nutrition
        /// </summary>
        [DataMember(Name = "nutrition", IsRequired = true, EmitDefaultValue = true)]
        public SearchGroceryProductsByUPC200ResponseNutrition Nutrition { get; set; }

        /// <summary>
        /// Gets or Sets Price
        /// </summary>
        [DataMember(Name = "price", IsRequired = true, EmitDefaultValue = true)]
        public decimal Price { get; set; }

        /// <summary>
        /// Gets or Sets Servings
        /// </summary>
        [DataMember(Name = "servings", IsRequired = true, EmitDefaultValue = true)]
        public SearchGroceryProductsByUPC200ResponseServings Servings { get; set; }

        /// <summary>
        /// Gets or Sets SpoonacularScore
        /// </summary>
        [DataMember(Name = "spoonacularScore", IsRequired = true, EmitDefaultValue = true)]
        public decimal SpoonacularScore { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class GetProductInformation200Response {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Breadcrumbs: ").Append(Breadcrumbs).Append("\n");
            sb.Append("  ImageType: ").Append(ImageType).Append("\n");
            sb.Append("  Badges: ").Append(Badges).Append("\n");
            sb.Append("  ImportantBadges: ").Append(ImportantBadges).Append("\n");
            sb.Append("  IngredientCount: ").Append(IngredientCount).Append("\n");
            sb.Append("  GeneratedText: ").Append(GeneratedText).Append("\n");
            sb.Append("  IngredientList: ").Append(IngredientList).Append("\n");
            sb.Append("  Ingredients: ").Append(Ingredients).Append("\n");
            sb.Append("  Likes: ").Append(Likes).Append("\n");
            sb.Append("  Aisle: ").Append(Aisle).Append("\n");
            sb.Append("  Nutrition: ").Append(Nutrition).Append("\n");
            sb.Append("  Price: ").Append(Price).Append("\n");
            sb.Append("  Servings: ").Append(Servings).Append("\n");
            sb.Append("  SpoonacularScore: ").Append(SpoonacularScore).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Title (string) minLength
            if (this.Title != null && this.Title.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Title, length must be greater than 1.", new [] { "Title" });
            }

            // ImageType (string) minLength
            if (this.ImageType != null && this.ImageType.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ImageType, length must be greater than 1.", new [] { "ImageType" });
            }

            // IngredientList (string) minLength
            if (this.IngredientList != null && this.IngredientList.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for IngredientList, length must be greater than 1.", new [] { "IngredientList" });
            }

            // Aisle (string) minLength
            if (this.Aisle != null && this.Aisle.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Aisle, length must be greater than 1.", new [] { "Aisle" });
            }

            yield break;
        }
    }

}
