/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = spoonacular.Client.OpenAPIDateConverter;

namespace spoonacular.Model
{
    /// <summary>
    /// GetRecipeNutritionWidgetByID200Response
    /// </summary>
    [DataContract(Name = "getRecipeNutritionWidgetByID_200_response")]
    public partial class GetRecipeNutritionWidgetByID200Response : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="GetRecipeNutritionWidgetByID200Response" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected GetRecipeNutritionWidgetByID200Response() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="GetRecipeNutritionWidgetByID200Response" /> class.
        /// </summary>
        /// <param name="calories">calories (required).</param>
        /// <param name="carbs">carbs (required).</param>
        /// <param name="fat">fat (required).</param>
        /// <param name="protein">protein (required).</param>
        /// <param name="bad">bad (required).</param>
        /// <param name="good">good (required).</param>
        public GetRecipeNutritionWidgetByID200Response(string calories = default(string), string carbs = default(string), string fat = default(string), string protein = default(string), List<GetRecipeNutritionWidgetByID200ResponseBadInner> bad = default(List<GetRecipeNutritionWidgetByID200ResponseBadInner>), List<GetRecipeNutritionWidgetByID200ResponseGoodInner> good = default(List<GetRecipeNutritionWidgetByID200ResponseGoodInner>))
        {
            // to ensure "calories" is required (not null)
            if (calories == null)
            {
                throw new ArgumentNullException("calories is a required property for GetRecipeNutritionWidgetByID200Response and cannot be null");
            }
            this.Calories = calories;
            // to ensure "carbs" is required (not null)
            if (carbs == null)
            {
                throw new ArgumentNullException("carbs is a required property for GetRecipeNutritionWidgetByID200Response and cannot be null");
            }
            this.Carbs = carbs;
            // to ensure "fat" is required (not null)
            if (fat == null)
            {
                throw new ArgumentNullException("fat is a required property for GetRecipeNutritionWidgetByID200Response and cannot be null");
            }
            this.Fat = fat;
            // to ensure "protein" is required (not null)
            if (protein == null)
            {
                throw new ArgumentNullException("protein is a required property for GetRecipeNutritionWidgetByID200Response and cannot be null");
            }
            this.Protein = protein;
            // to ensure "bad" is required (not null)
            if (bad == null)
            {
                throw new ArgumentNullException("bad is a required property for GetRecipeNutritionWidgetByID200Response and cannot be null");
            }
            this.Bad = bad;
            // to ensure "good" is required (not null)
            if (good == null)
            {
                throw new ArgumentNullException("good is a required property for GetRecipeNutritionWidgetByID200Response and cannot be null");
            }
            this.Good = good;
        }

        /// <summary>
        /// Gets or Sets Calories
        /// </summary>
        [DataMember(Name = "calories", IsRequired = true, EmitDefaultValue = true)]
        public string Calories { get; set; }

        /// <summary>
        /// Gets or Sets Carbs
        /// </summary>
        [DataMember(Name = "carbs", IsRequired = true, EmitDefaultValue = true)]
        public string Carbs { get; set; }

        /// <summary>
        /// Gets or Sets Fat
        /// </summary>
        [DataMember(Name = "fat", IsRequired = true, EmitDefaultValue = true)]
        public string Fat { get; set; }

        /// <summary>
        /// Gets or Sets Protein
        /// </summary>
        [DataMember(Name = "protein", IsRequired = true, EmitDefaultValue = true)]
        public string Protein { get; set; }

        /// <summary>
        /// Gets or Sets Bad
        /// </summary>
        [DataMember(Name = "bad", IsRequired = true, EmitDefaultValue = true)]
        public List<GetRecipeNutritionWidgetByID200ResponseBadInner> Bad { get; set; }

        /// <summary>
        /// Gets or Sets Good
        /// </summary>
        [DataMember(Name = "good", IsRequired = true, EmitDefaultValue = true)]
        public List<GetRecipeNutritionWidgetByID200ResponseGoodInner> Good { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class GetRecipeNutritionWidgetByID200Response {\n");
            sb.Append("  Calories: ").Append(Calories).Append("\n");
            sb.Append("  Carbs: ").Append(Carbs).Append("\n");
            sb.Append("  Fat: ").Append(Fat).Append("\n");
            sb.Append("  Protein: ").Append(Protein).Append("\n");
            sb.Append("  Bad: ").Append(Bad).Append("\n");
            sb.Append("  Good: ").Append(Good).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Calories (string) minLength
            if (this.Calories != null && this.Calories.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Calories, length must be greater than 1.", new [] { "Calories" });
            }

            // Carbs (string) minLength
            if (this.Carbs != null && this.Carbs.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Carbs, length must be greater than 1.", new [] { "Carbs" });
            }

            // Fat (string) minLength
            if (this.Fat != null && this.Fat.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Fat, length must be greater than 1.", new [] { "Fat" });
            }

            // Protein (string) minLength
            if (this.Protein != null && this.Protein.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Protein, length must be greater than 1.", new [] { "Protein" });
            }

            yield break;
        }
    }

}
