/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = spoonacular.Client.OpenAPIDateConverter;

namespace spoonacular.Model
{
    /// <summary>
    /// MapIngredientsToGroceryProducts200ResponseInner
    /// </summary>
    [DataContract(Name = "mapIngredientsToGroceryProducts_200_response_inner")]
    public partial class MapIngredientsToGroceryProducts200ResponseInner : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MapIngredientsToGroceryProducts200ResponseInner" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected MapIngredientsToGroceryProducts200ResponseInner() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="MapIngredientsToGroceryProducts200ResponseInner" /> class.
        /// </summary>
        /// <param name="original">original (required).</param>
        /// <param name="originalName">originalName (required).</param>
        /// <param name="ingredientImage">ingredientImage (required).</param>
        /// <param name="meta">meta (required).</param>
        /// <param name="products">products (required).</param>
        public MapIngredientsToGroceryProducts200ResponseInner(string original = default(string), string originalName = default(string), string ingredientImage = default(string), List<string> meta = default(List<string>), List<MapIngredientsToGroceryProducts200ResponseInnerProductsInner> products = default(List<MapIngredientsToGroceryProducts200ResponseInnerProductsInner>))
        {
            // to ensure "original" is required (not null)
            if (original == null)
            {
                throw new ArgumentNullException("original is a required property for MapIngredientsToGroceryProducts200ResponseInner and cannot be null");
            }
            this.Original = original;
            // to ensure "originalName" is required (not null)
            if (originalName == null)
            {
                throw new ArgumentNullException("originalName is a required property for MapIngredientsToGroceryProducts200ResponseInner and cannot be null");
            }
            this.OriginalName = originalName;
            // to ensure "ingredientImage" is required (not null)
            if (ingredientImage == null)
            {
                throw new ArgumentNullException("ingredientImage is a required property for MapIngredientsToGroceryProducts200ResponseInner and cannot be null");
            }
            this.IngredientImage = ingredientImage;
            // to ensure "meta" is required (not null)
            if (meta == null)
            {
                throw new ArgumentNullException("meta is a required property for MapIngredientsToGroceryProducts200ResponseInner and cannot be null");
            }
            this.Meta = meta;
            // to ensure "products" is required (not null)
            if (products == null)
            {
                throw new ArgumentNullException("products is a required property for MapIngredientsToGroceryProducts200ResponseInner and cannot be null");
            }
            this.Products = products;
        }

        /// <summary>
        /// Gets or Sets Original
        /// </summary>
        [DataMember(Name = "original", IsRequired = true, EmitDefaultValue = true)]
        public string Original { get; set; }

        /// <summary>
        /// Gets or Sets OriginalName
        /// </summary>
        [DataMember(Name = "originalName", IsRequired = true, EmitDefaultValue = true)]
        public string OriginalName { get; set; }

        /// <summary>
        /// Gets or Sets IngredientImage
        /// </summary>
        [DataMember(Name = "ingredientImage", IsRequired = true, EmitDefaultValue = true)]
        public string IngredientImage { get; set; }

        /// <summary>
        /// Gets or Sets Meta
        /// </summary>
        [DataMember(Name = "meta", IsRequired = true, EmitDefaultValue = true)]
        public List<string> Meta { get; set; }

        /// <summary>
        /// Gets or Sets Products
        /// </summary>
        [DataMember(Name = "products", IsRequired = true, EmitDefaultValue = true)]
        public List<MapIngredientsToGroceryProducts200ResponseInnerProductsInner> Products { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class MapIngredientsToGroceryProducts200ResponseInner {\n");
            sb.Append("  Original: ").Append(Original).Append("\n");
            sb.Append("  OriginalName: ").Append(OriginalName).Append("\n");
            sb.Append("  IngredientImage: ").Append(IngredientImage).Append("\n");
            sb.Append("  Meta: ").Append(Meta).Append("\n");
            sb.Append("  Products: ").Append(Products).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Original (string) minLength
            if (this.Original != null && this.Original.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Original, length must be greater than 1.", new [] { "Original" });
            }

            // OriginalName (string) minLength
            if (this.OriginalName != null && this.OriginalName.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for OriginalName, length must be greater than 1.", new [] { "OriginalName" });
            }

            // IngredientImage (string) minLength
            if (this.IngredientImage != null && this.IngredientImage.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for IngredientImage, length must be greater than 1.", new [] { "IngredientImage" });
            }

            yield break;
        }
    }

}
