/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = spoonacular.Client.OpenAPIDateConverter;

namespace spoonacular.Model
{
    /// <summary>
    /// SearchFoodVideos200ResponseVideosInner
    /// </summary>
    [DataContract(Name = "searchFoodVideos_200_response_videos_inner")]
    public partial class SearchFoodVideos200ResponseVideosInner : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SearchFoodVideos200ResponseVideosInner" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected SearchFoodVideos200ResponseVideosInner() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="SearchFoodVideos200ResponseVideosInner" /> class.
        /// </summary>
        /// <param name="title">title (required).</param>
        /// <param name="length">length (required).</param>
        /// <param name="rating">rating (required).</param>
        /// <param name="shortTitle">shortTitle (required).</param>
        /// <param name="thumbnail">thumbnail (required).</param>
        /// <param name="views">views (required).</param>
        /// <param name="youTubeId">youTubeId (required).</param>
        public SearchFoodVideos200ResponseVideosInner(string title = default(string), int length = default(int), decimal rating = default(decimal), string shortTitle = default(string), string thumbnail = default(string), int views = default(int), string youTubeId = default(string))
        {
            // to ensure "title" is required (not null)
            if (title == null)
            {
                throw new ArgumentNullException("title is a required property for SearchFoodVideos200ResponseVideosInner and cannot be null");
            }
            this.Title = title;
            this.Length = length;
            this.Rating = rating;
            // to ensure "shortTitle" is required (not null)
            if (shortTitle == null)
            {
                throw new ArgumentNullException("shortTitle is a required property for SearchFoodVideos200ResponseVideosInner and cannot be null");
            }
            this.ShortTitle = shortTitle;
            // to ensure "thumbnail" is required (not null)
            if (thumbnail == null)
            {
                throw new ArgumentNullException("thumbnail is a required property for SearchFoodVideos200ResponseVideosInner and cannot be null");
            }
            this.Thumbnail = thumbnail;
            this.Views = views;
            // to ensure "youTubeId" is required (not null)
            if (youTubeId == null)
            {
                throw new ArgumentNullException("youTubeId is a required property for SearchFoodVideos200ResponseVideosInner and cannot be null");
            }
            this.YouTubeId = youTubeId;
        }

        /// <summary>
        /// Gets or Sets Title
        /// </summary>
        [DataMember(Name = "title", IsRequired = true, EmitDefaultValue = true)]
        public string Title { get; set; }

        /// <summary>
        /// Gets or Sets Length
        /// </summary>
        [DataMember(Name = "length", IsRequired = true, EmitDefaultValue = true)]
        public int Length { get; set; }

        /// <summary>
        /// Gets or Sets Rating
        /// </summary>
        [DataMember(Name = "rating", IsRequired = true, EmitDefaultValue = true)]
        public decimal Rating { get; set; }

        /// <summary>
        /// Gets or Sets ShortTitle
        /// </summary>
        [DataMember(Name = "shortTitle", IsRequired = true, EmitDefaultValue = true)]
        public string ShortTitle { get; set; }

        /// <summary>
        /// Gets or Sets Thumbnail
        /// </summary>
        [DataMember(Name = "thumbnail", IsRequired = true, EmitDefaultValue = true)]
        public string Thumbnail { get; set; }

        /// <summary>
        /// Gets or Sets Views
        /// </summary>
        [DataMember(Name = "views", IsRequired = true, EmitDefaultValue = true)]
        public int Views { get; set; }

        /// <summary>
        /// Gets or Sets YouTubeId
        /// </summary>
        [DataMember(Name = "youTubeId", IsRequired = true, EmitDefaultValue = true)]
        public string YouTubeId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class SearchFoodVideos200ResponseVideosInner {\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Length: ").Append(Length).Append("\n");
            sb.Append("  Rating: ").Append(Rating).Append("\n");
            sb.Append("  ShortTitle: ").Append(ShortTitle).Append("\n");
            sb.Append("  Thumbnail: ").Append(Thumbnail).Append("\n");
            sb.Append("  Views: ").Append(Views).Append("\n");
            sb.Append("  YouTubeId: ").Append(YouTubeId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Title (string) minLength
            if (this.Title != null && this.Title.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Title, length must be greater than 1.", new [] { "Title" });
            }

            // ShortTitle (string) minLength
            if (this.ShortTitle != null && this.ShortTitle.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ShortTitle, length must be greater than 1.", new [] { "ShortTitle" });
            }

            // Thumbnail (string) minLength
            if (this.Thumbnail != null && this.Thumbnail.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Thumbnail, length must be greater than 1.", new [] { "Thumbnail" });
            }

            // YouTubeId (string) minLength
            if (this.YouTubeId != null && this.YouTubeId.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for YouTubeId, length must be greater than 1.", new [] { "YouTubeId" });
            }

            yield break;
        }
    }

}
