/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = spoonacular.Client.OpenAPIDateConverter;

namespace spoonacular.Model
{
    /// <summary>
    /// SearchGroceryProducts200Response
    /// </summary>
    [DataContract(Name = "searchGroceryProducts_200_response")]
    public partial class SearchGroceryProducts200Response : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SearchGroceryProducts200Response" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected SearchGroceryProducts200Response() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="SearchGroceryProducts200Response" /> class.
        /// </summary>
        /// <param name="products">products (required).</param>
        /// <param name="totalProducts">totalProducts (required).</param>
        /// <param name="type">type (required).</param>
        /// <param name="offset">offset (required).</param>
        /// <param name="number">number (required).</param>
        public SearchGroceryProducts200Response(List<AutocompleteRecipeSearch200ResponseInner> products = default(List<AutocompleteRecipeSearch200ResponseInner>), int totalProducts = default(int), string type = default(string), int offset = default(int), int number = default(int))
        {
            // to ensure "products" is required (not null)
            if (products == null)
            {
                throw new ArgumentNullException("products is a required property for SearchGroceryProducts200Response and cannot be null");
            }
            this.Products = products;
            this.TotalProducts = totalProducts;
            // to ensure "type" is required (not null)
            if (type == null)
            {
                throw new ArgumentNullException("type is a required property for SearchGroceryProducts200Response and cannot be null");
            }
            this.Type = type;
            this.Offset = offset;
            this.Number = number;
        }

        /// <summary>
        /// Gets or Sets Products
        /// </summary>
        [DataMember(Name = "products", IsRequired = true, EmitDefaultValue = true)]
        public List<AutocompleteRecipeSearch200ResponseInner> Products { get; set; }

        /// <summary>
        /// Gets or Sets TotalProducts
        /// </summary>
        [DataMember(Name = "totalProducts", IsRequired = true, EmitDefaultValue = true)]
        public int TotalProducts { get; set; }

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name = "type", IsRequired = true, EmitDefaultValue = true)]
        public string Type { get; set; }

        /// <summary>
        /// Gets or Sets Offset
        /// </summary>
        [DataMember(Name = "offset", IsRequired = true, EmitDefaultValue = true)]
        public int Offset { get; set; }

        /// <summary>
        /// Gets or Sets Number
        /// </summary>
        [DataMember(Name = "number", IsRequired = true, EmitDefaultValue = true)]
        public int Number { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class SearchGroceryProducts200Response {\n");
            sb.Append("  Products: ").Append(Products).Append("\n");
            sb.Append("  TotalProducts: ").Append(TotalProducts).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  Offset: ").Append(Offset).Append("\n");
            sb.Append("  Number: ").Append(Number).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Type (string) minLength
            if (this.Type != null && this.Type.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Type, length must be greater than 1.", new [] { "Type" });
            }

            yield break;
        }
    }

}
