/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = spoonacular.Client.OpenAPIDateConverter;

namespace spoonacular.Model
{
    /// <summary>
    /// SearchSiteContent200Response
    /// </summary>
    [DataContract(Name = "searchSiteContent_200_response")]
    public partial class SearchSiteContent200Response : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SearchSiteContent200Response" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected SearchSiteContent200Response() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="SearchSiteContent200Response" /> class.
        /// </summary>
        /// <param name="articles">articles (required).</param>
        /// <param name="groceryProducts">groceryProducts (required).</param>
        /// <param name="menuItems">menuItems (required).</param>
        /// <param name="recipes">recipes (required).</param>
        public SearchSiteContent200Response(List<SearchSiteContent200ResponseArticlesInner> articles = default(List<SearchSiteContent200ResponseArticlesInner>), List<SearchSiteContent200ResponseGroceryProductsInner> groceryProducts = default(List<SearchSiteContent200ResponseGroceryProductsInner>), List<SearchSiteContent200ResponseGroceryProductsInner> menuItems = default(List<SearchSiteContent200ResponseGroceryProductsInner>), List<SearchSiteContent200ResponseGroceryProductsInner> recipes = default(List<SearchSiteContent200ResponseGroceryProductsInner>))
        {
            // to ensure "articles" is required (not null)
            if (articles == null)
            {
                throw new ArgumentNullException("articles is a required property for SearchSiteContent200Response and cannot be null");
            }
            this.Articles = articles;
            // to ensure "groceryProducts" is required (not null)
            if (groceryProducts == null)
            {
                throw new ArgumentNullException("groceryProducts is a required property for SearchSiteContent200Response and cannot be null");
            }
            this.GroceryProducts = groceryProducts;
            // to ensure "menuItems" is required (not null)
            if (menuItems == null)
            {
                throw new ArgumentNullException("menuItems is a required property for SearchSiteContent200Response and cannot be null");
            }
            this.MenuItems = menuItems;
            // to ensure "recipes" is required (not null)
            if (recipes == null)
            {
                throw new ArgumentNullException("recipes is a required property for SearchSiteContent200Response and cannot be null");
            }
            this.Recipes = recipes;
        }

        /// <summary>
        /// Gets or Sets Articles
        /// </summary>
        [DataMember(Name = "Articles", IsRequired = true, EmitDefaultValue = true)]
        public List<SearchSiteContent200ResponseArticlesInner> Articles { get; set; }

        /// <summary>
        /// Gets or Sets GroceryProducts
        /// </summary>
        [DataMember(Name = "Grocery Products", IsRequired = true, EmitDefaultValue = true)]
        public List<SearchSiteContent200ResponseGroceryProductsInner> GroceryProducts { get; set; }

        /// <summary>
        /// Gets or Sets MenuItems
        /// </summary>
        [DataMember(Name = "Menu Items", IsRequired = true, EmitDefaultValue = true)]
        public List<SearchSiteContent200ResponseGroceryProductsInner> MenuItems { get; set; }

        /// <summary>
        /// Gets or Sets Recipes
        /// </summary>
        [DataMember(Name = "Recipes", IsRequired = true, EmitDefaultValue = true)]
        public List<SearchSiteContent200ResponseGroceryProductsInner> Recipes { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class SearchSiteContent200Response {\n");
            sb.Append("  Articles: ").Append(Articles).Append("\n");
            sb.Append("  GroceryProducts: ").Append(GroceryProducts).Append("\n");
            sb.Append("  MenuItems: ").Append(MenuItems).Append("\n");
            sb.Append("  Recipes: ").Append(Recipes).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
