/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = spoonacular.Client.OpenAPIDateConverter;

namespace spoonacular.Model
{
    /// <summary>
    /// TalkToChatbot200Response
    /// </summary>
    [DataContract(Name = "talkToChatbot_200_response")]
    public partial class TalkToChatbot200Response : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TalkToChatbot200Response" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected TalkToChatbot200Response() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="TalkToChatbot200Response" /> class.
        /// </summary>
        /// <param name="answerText">answerText (required).</param>
        /// <param name="media">media (required).</param>
        public TalkToChatbot200Response(string answerText = default(string), List<Object> media = default(List<Object>))
        {
            // to ensure "answerText" is required (not null)
            if (answerText == null)
            {
                throw new ArgumentNullException("answerText is a required property for TalkToChatbot200Response and cannot be null");
            }
            this.AnswerText = answerText;
            // to ensure "media" is required (not null)
            if (media == null)
            {
                throw new ArgumentNullException("media is a required property for TalkToChatbot200Response and cannot be null");
            }
            this.Media = media;
        }

        /// <summary>
        /// Gets or Sets AnswerText
        /// </summary>
        [DataMember(Name = "answerText", IsRequired = true, EmitDefaultValue = true)]
        public string AnswerText { get; set; }

        /// <summary>
        /// Gets or Sets Media
        /// </summary>
        [DataMember(Name = "media", IsRequired = true, EmitDefaultValue = true)]
        public List<Object> Media { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class TalkToChatbot200Response {\n");
            sb.Append("  AnswerText: ").Append(AnswerText).Append("\n");
            sb.Append("  Media: ").Append(Media).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // AnswerText (string) minLength
            if (this.AnswerText != null && this.AnswerText.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for AnswerText, length must be greater than 1.", new [] { "AnswerText" });
            }

            yield break;
        }
    }

}
